!!! 5
%html
  %head
    %title= "Results"
    :css
      html, body { text-align:center; margin:0; padding:0 }
      canvas { background:url(Image.jpg); display:block; margin:1em auto; width:1608px; height:853px }
  %body
    %form(method="post" action="/delete")
      %select(name="id")
        / %option(value="") (pick)
        %option(value="all") (all)
        - @hits.each do |hit|
          %option{value:hit[:id]}= hit[:name]
      %button Delete
    <canvas id="cnv" width="1608" height="853"></canvas>
    :javascript
      var hits = #{ @hits.to_json };
      var pointsById = {};
      for (var i=hits.length;i--;) pointsById[hits[i].id] = eval('o = '+hits[i].results);
      var s = document.querySelector('select');
      var ctx = document.querySelector('canvas').getContext('2d');
      var colorByRegion = {
        'AC.png':          'rgba(255,34,0,0.6)',
        'Back.png':        'rgba(218,230,57,0.6)',
        'Climate.png':     'rgba(242,129,0,0.6)',
        'Defog.png':       'rgba(140,19,0,0.6)',
        'Defrost.png':     'rgba(191,115,230,0.6)',
        'Driver.png':      'rgba(68,255,0,0.6)',
        'DriverHeat.png':  'rgba(64,191,255,0.6)',
        'Home.png':        'rgba(153,0,122,0.6)',
        'Music.png':       'rgba(229,145,115,0.6)',
        'Nav.png':         'rgba(48,191,86,0.6)',
        'PassClimate.png': 'rgba(0,102,191,0.6)',
        'PassHeat.png':    'rgba(255,128,179,0.6)',
        'Phone.png':       'rgba(0,202,217,0.6)',
        'Settings.png':    'rgba(64,128,98,0.6)',
      };

      s.onchange = function(){
        ctx.clearRect(0,0,1608,853);
        if (!s.value) return;
        if (s.value=='all') for (var id in pointsById) drawForId(id);
        else drawForId(s.value);
        drawMedians();
      };

      function drawForId(id){
        var points = pointsById[id];
        var c=0;
        for (var region in points){
          var mx = medianByRegion[region][0],
              my = medianByRegion[region][1];
          var xys = points[region];
          ctx.fillStyle = colorByRegion[region];
          for (var i=xys.length;i--;){
            var x = xys[i][0],
                y = xys[i][1];
            var dist = Math.sqrt(Math.pow(mx-x,2)+Math.pow(my-y,2));
            if (dist < 280) ctx.fillRect(x-2,y-2,5,5);
            else console.log("Skipping "+region+" outlier at "+x+","+y);
          }
        }
      }

      var medianByRegion = {};
      function calculateMedians(){
        var byRegion = {};
        for (var id in pointsById){
          for (var region in pointsById[id]){
            byRegion[region] = (byRegion[region] || []).concat(pointsById[id][region]);
          }
        }
        for (var region in byRegion){
          medianByRegion[region] = [
            median( byRegion[region].map(function(a){ return a[0] }) ),
            median( byRegion[region].map(function(a){ return a[1] }) )
          ];
        }
      }

      function drawMedians(){
        for (var region in medianByRegion){
          var xy = medianByRegion[region];
          ctx.beginPath();
          ctx.arc(xy[0], xy[1], 9, 0, 2 * Math.PI, false);
          ctx.lineWidth = 2;
          ctx.stroke();
        }
      }

      calculateMedians();
      console.log(medianByRegion);
      if (#{(!!params[:id]).inspect}) s.value = #{params[:id]||0};
      s.onchange();

      function median(array){
        var a = array.concat().sort();
        var half = Math.floor(a.length/2);
        return (a.length % 2) ? a[half] : ((a[half-1] + a[half]) / 2);
      }
